# coding: utf-8

"""
    public/portworx/pds/backup/apiv1/backup.proto

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: version not set
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from portworxapis.models.v1_azure_blob_storage import V1AzureBlobStorage
from portworxapis.models.v1_google_cloud_storage import V1GoogleCloudStorage
from portworxapis.models.v1_provider import V1Provider
from portworxapis.models.v1_s3_object_storage import V1S3ObjectStorage
from typing import Optional, Set
from typing_extensions import Self

class Platformbackuplocationv1Config(BaseModel):
    """
    Desired configuration of the backup location.
    """ # noqa: E501
    provider: Optional[V1Provider] = None
    cloud_credential_id: Optional[StrictStr] = Field(default=None, description="id of the cloud credential associated with the backup location.", alias="cloudCredentialId")
    azure_storage: Optional[V1AzureBlobStorage] = Field(default=None, alias="azureStorage")
    google_storage: Optional[V1GoogleCloudStorage] = Field(default=None, alias="googleStorage")
    s3_storage: Optional[V1S3ObjectStorage] = Field(default=None, alias="s3Storage")
    __properties: ClassVar[List[str]] = ["provider", "cloudCredentialId", "azureStorage", "googleStorage", "s3Storage"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Platformbackuplocationv1Config from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of provider
        if self.provider:
            _dict['provider'] = self.provider.to_dict()
        # override the default output from pydantic by calling `to_dict()` of azure_storage
        if self.azure_storage:
            _dict['azureStorage'] = self.azure_storage.to_dict()
        # override the default output from pydantic by calling `to_dict()` of google_storage
        if self.google_storage:
            _dict['googleStorage'] = self.google_storage.to_dict()
        # override the default output from pydantic by calling `to_dict()` of s3_storage
        if self.s3_storage:
            _dict['s3Storage'] = self.s3_storage.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Platformbackuplocationv1Config from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "provider": V1Provider.from_dict(obj["provider"]) if obj.get("provider") is not None else None,
            "cloudCredentialId": obj.get("cloudCredentialId"),
            "azureStorage": V1AzureBlobStorage.from_dict(obj["azureStorage"]) if obj.get("azureStorage") is not None else None,
            "googleStorage": V1GoogleCloudStorage.from_dict(obj["googleStorage"]) if obj.get("googleStorage") is not None else None,
            "s3Storage": V1S3ObjectStorage.from_dict(obj["s3Storage"]) if obj.get("s3Storage") is not None else None
        })
        return _obj


