# coding: utf-8

"""
    public/portworx/pds/backup/apiv1/backup.proto

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: version not set
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from portworxapis.models.v1_data_service_version import V1DataServiceVersion
from typing import Optional, Set
from typing_extensions import Self

class V1CompatibleVersions(BaseModel):
    """
    CompatibleVersions contains compatibility information for a particular Version.
    """ # noqa: E501
    data_service_id: Optional[StrictStr] = Field(default=None, description="UID of the data service.", alias="dataServiceId")
    data_service_name: Optional[StrictStr] = Field(default=None, description="Name of the data service.", alias="dataServiceName")
    data_service_version_id: Optional[StrictStr] = Field(default=None, description="UID of the data service version.", alias="dataServiceVersionId")
    data_service_version_name: Optional[StrictStr] = Field(default=None, description="Name of the data service version.", alias="dataServiceVersionName")
    latest_compatible_patch: Optional[V1DataServiceVersion] = Field(default=None, alias="latestCompatiblePatch")
    latest_compatible_versions: Optional[List[V1DataServiceVersion]] = Field(default=None, description="LatestCompatibleVersions contains the latest patch versions of compatible major/minor versions.", alias="latestCompatibleVersions")
    compatible_versions: Optional[List[V1DataServiceVersion]] = Field(default=None, description="CompatibleVersions contains all compatible versions.", alias="compatibleVersions")
    __properties: ClassVar[List[str]] = ["dataServiceId", "dataServiceName", "dataServiceVersionId", "dataServiceVersionName", "latestCompatiblePatch", "latestCompatibleVersions", "compatibleVersions"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of V1CompatibleVersions from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of latest_compatible_patch
        if self.latest_compatible_patch:
            _dict['latestCompatiblePatch'] = self.latest_compatible_patch.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in latest_compatible_versions (list)
        _items = []
        if self.latest_compatible_versions:
            for _item_latest_compatible_versions in self.latest_compatible_versions:
                if _item_latest_compatible_versions:
                    _items.append(_item_latest_compatible_versions.to_dict())
            _dict['latestCompatibleVersions'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in compatible_versions (list)
        _items = []
        if self.compatible_versions:
            for _item_compatible_versions in self.compatible_versions:
                if _item_compatible_versions:
                    _items.append(_item_compatible_versions.to_dict())
            _dict['compatibleVersions'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of V1CompatibleVersions from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "dataServiceId": obj.get("dataServiceId"),
            "dataServiceName": obj.get("dataServiceName"),
            "dataServiceVersionId": obj.get("dataServiceVersionId"),
            "dataServiceVersionName": obj.get("dataServiceVersionName"),
            "latestCompatiblePatch": V1DataServiceVersion.from_dict(obj["latestCompatiblePatch"]) if obj.get("latestCompatiblePatch") is not None else None,
            "latestCompatibleVersions": [V1DataServiceVersion.from_dict(_item) for _item in obj["latestCompatibleVersions"]] if obj.get("latestCompatibleVersions") is not None else None,
            "compatibleVersions": [V1DataServiceVersion.from_dict(_item) for _item in obj["compatibleVersions"]] if obj.get("compatibleVersions") is not None else None
        })
        return _obj


