# coding: utf-8

"""
    public/portworx/pds/backup/apiv1/backup.proto

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: version not set
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from portworxapis.models.v1_connection_details import V1ConnectionDetails
from portworxapis.models.v1_instance_info import V1InstanceInfo
from typing import Optional, Set
from typing_extensions import Self

class V1ConnectionInfo(BaseModel):
    """
    Connection Information for the DataServiceDeployment Topology.
    """ # noqa: E501
    ready_instances: Optional[List[V1InstanceInfo]] = Field(default=None, description="Ready instances.", alias="readyInstances")
    not_ready_instances: Optional[List[V1InstanceInfo]] = Field(default=None, description="Instances that are not ready.", alias="notReadyInstances")
    connection_details: Optional[V1ConnectionDetails] = Field(default=None, alias="connectionDetails")
    cluster_details: Optional[Dict[str, Any]] = Field(default=None, description="Stores details about the cluster.", alias="clusterDetails")
    __properties: ClassVar[List[str]] = ["readyInstances", "notReadyInstances", "connectionDetails", "clusterDetails"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of V1ConnectionInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in ready_instances (list)
        _items = []
        if self.ready_instances:
            for _item_ready_instances in self.ready_instances:
                if _item_ready_instances:
                    _items.append(_item_ready_instances.to_dict())
            _dict['readyInstances'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in not_ready_instances (list)
        _items = []
        if self.not_ready_instances:
            for _item_not_ready_instances in self.not_ready_instances:
                if _item_not_ready_instances:
                    _items.append(_item_not_ready_instances.to_dict())
            _dict['notReadyInstances'] = _items
        # override the default output from pydantic by calling `to_dict()` of connection_details
        if self.connection_details:
            _dict['connectionDetails'] = self.connection_details.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of V1ConnectionInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "readyInstances": [V1InstanceInfo.from_dict(_item) for _item in obj["readyInstances"]] if obj.get("readyInstances") is not None else None,
            "notReadyInstances": [V1InstanceInfo.from_dict(_item) for _item in obj["notReadyInstances"]] if obj.get("notReadyInstances") is not None else None,
            "connectionDetails": V1ConnectionDetails.from_dict(obj["connectionDetails"]) if obj.get("connectionDetails") is not None else None,
            "clusterDetails": obj.get("clusterDetails")
        })
        return _obj


