# coding: utf-8

"""
    public/portworx/pds/backup/apiv1/backup.proto

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: version not set
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class V1CustomImageRegistryConfig(BaseModel):
    """
    CustomImageRegistryConfig holds image registry credential configs.
    """ # noqa: E501
    registry_url: Optional[StrictStr] = Field(default=None, description="registry url/domain, e.g. - in org.example.com/namespace/sub-namespace/repo:tag, here `org.example.com` is the registry url.", alias="registryUrl")
    registry_namespace: Optional[StrictStr] = Field(default=None, description="registry namespace, e.g. - in org.example.com/namespace/sub-namespace/repo:tag, here `namespace/sub-namespace` is the registry namespace.", alias="registryNamespace")
    username: Optional[StrictStr] = Field(default=None, description="username for authenticating to a private registry.")
    password: Optional[StrictStr] = Field(default=None, description="password for authenticating to a private registry.")
    ca_cert: Optional[StrictStr] = Field(default=None, description="ca cert of the registry server.", alias="caCert")
    __properties: ClassVar[List[str]] = ["registryUrl", "registryNamespace", "username", "password", "caCert"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of V1CustomImageRegistryConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of V1CustomImageRegistryConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "registryUrl": obj.get("registryUrl"),
            "registryNamespace": obj.get("registryNamespace"),
            "username": obj.get("username"),
            "password": obj.get("password"),
            "caCert": obj.get("caCert")
        })
        return _obj


