# coding: utf-8

"""
    public/portworx/pds/backup/apiv1/backup.proto

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: version not set
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class V1DataServiceDeploymentMetaData1(BaseModel):
    """
    DataServiceDeployment Meta Data contains the details of the DataService deployment associated with the backup configuration.
    """ # noqa: E501
    name: Optional[StrictStr] = Field(default=None, description="Name of the DataService deployment.")
    custom_resource_name: Optional[StrictStr] = Field(default=None, description="Custom Resource Name is the kubernetes resource name for the deployment meta data.", alias="customResourceName")
    target_cluster_name: Optional[StrictStr] = Field(default=None, description="Target cluster Name associated with the backup configuration.", alias="targetClusterName")
    namespace_name: Optional[StrictStr] = Field(default=None, description="Namespace name to which the backup configuration is associated.", alias="namespaceName")
    tls_enabled: Optional[StrictBool] = Field(default=None, description="Flag to check whether Transport Layer Security support is enabled or not.", alias="tlsEnabled")
    __properties: ClassVar[List[str]] = ["name", "customResourceName", "targetClusterName", "namespaceName", "tlsEnabled"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of V1DataServiceDeploymentMetaData1 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "custom_resource_name",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of V1DataServiceDeploymentMetaData1 from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "customResourceName": obj.get("customResourceName"),
            "targetClusterName": obj.get("targetClusterName"),
            "namespaceName": obj.get("namespaceName"),
            "tlsEnabled": obj.get("tlsEnabled")
        })
        return _obj


