# coding: utf-8

"""
    public/portworx/pds/backup/apiv1/backup.proto

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: version not set
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from portworxapis.models.v1_page_based_pagination_request import V1PageBasedPaginationRequest
from portworxapis.models.v1_pds_application_selector import V1PDSApplicationSelector
from portworxapis.models.v1_resource_selector import V1ResourceSelector
from portworxapis.models.v1_selector import V1Selector
from portworxapis.models.v1_sort1 import V1Sort1
from typing import Optional, Set
from typing_extensions import Self

class V1ListDataServiceDeploymentsRequest(BaseModel):
    """
    Request to list the data service deployment resources.
    """ # noqa: E501
    tenant_id: StrictStr = Field(description="tenant ID for which data service deployments need to be fetched.", alias="tenantId")
    label_selector: Optional[V1Selector] = Field(default=None, alias="labelSelector")
    field_selector: Optional[V1Selector] = Field(default=None, alias="fieldSelector")
    infra_resource_selector: Optional[V1ResourceSelector] = Field(default=None, alias="infraResourceSelector")
    sort: Optional[V1Sort1] = None
    pagination: Optional[V1PageBasedPaginationRequest] = None
    application_selector: Optional[V1PDSApplicationSelector] = Field(default=None, alias="applicationSelector")
    __properties: ClassVar[List[str]] = ["tenantId", "labelSelector", "fieldSelector", "infraResourceSelector", "sort", "pagination", "applicationSelector"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of V1ListDataServiceDeploymentsRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of label_selector
        if self.label_selector:
            _dict['labelSelector'] = self.label_selector.to_dict()
        # override the default output from pydantic by calling `to_dict()` of field_selector
        if self.field_selector:
            _dict['fieldSelector'] = self.field_selector.to_dict()
        # override the default output from pydantic by calling `to_dict()` of infra_resource_selector
        if self.infra_resource_selector:
            _dict['infraResourceSelector'] = self.infra_resource_selector.to_dict()
        # override the default output from pydantic by calling `to_dict()` of sort
        if self.sort:
            _dict['sort'] = self.sort.to_dict()
        # override the default output from pydantic by calling `to_dict()` of pagination
        if self.pagination:
            _dict['pagination'] = self.pagination.to_dict()
        # override the default output from pydantic by calling `to_dict()` of application_selector
        if self.application_selector:
            _dict['applicationSelector'] = self.application_selector.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of V1ListDataServiceDeploymentsRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "tenantId": obj.get("tenantId"),
            "labelSelector": V1Selector.from_dict(obj["labelSelector"]) if obj.get("labelSelector") is not None else None,
            "fieldSelector": V1Selector.from_dict(obj["fieldSelector"]) if obj.get("fieldSelector") is not None else None,
            "infraResourceSelector": V1ResourceSelector.from_dict(obj["infraResourceSelector"]) if obj.get("infraResourceSelector") is not None else None,
            "sort": V1Sort1.from_dict(obj["sort"]) if obj.get("sort") is not None else None,
            "pagination": V1PageBasedPaginationRequest.from_dict(obj["pagination"]) if obj.get("pagination") is not None else None,
            "applicationSelector": V1PDSApplicationSelector.from_dict(obj["applicationSelector"]) if obj.get("applicationSelector") is not None else None
        })
        return _obj


