# coding: utf-8

"""
    public/portworx/pds/backup/apiv1/backup.proto

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: version not set
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class V1Resources(BaseModel):
    """
    Infra resource are platform managed resources, used by associated applications.
    """ # noqa: E501
    clusters: Optional[List[StrictStr]] = Field(default=None, description="Clusters represents the target k8s clusters.")
    namespaces: Optional[List[StrictStr]] = Field(default=None, description="Namespaces created in k8s cluster to provide the logical isolation.")
    credentials: Optional[List[StrictStr]] = Field(default=None, description="Credentials required to connect to a backup target.")
    backup_locations: Optional[List[StrictStr]] = Field(default=None, description="Backup locations where backups can be placed.", alias="backupLocations")
    templates: Optional[List[StrictStr]] = Field(default=None, description="Templates can be used by applications to manage its resources.")
    backup_policies: Optional[List[StrictStr]] = Field(default=None, description="Backup Policies where the schedules are defined.", alias="backupPolicies")
    __properties: ClassVar[List[str]] = ["clusters", "namespaces", "credentials", "backupLocations", "templates", "backupPolicies"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of V1Resources from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of V1Resources from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "clusters": obj.get("clusters"),
            "namespaces": obj.get("namespaces"),
            "credentials": obj.get("credentials"),
            "backupLocations": obj.get("backupLocations"),
            "templates": obj.get("templates"),
            "backupPolicies": obj.get("backupPolicies")
        })
        return _obj


